--
-- moresilotype
-- 
-- 
--
-- derelky 
-- Version 1.0 - 




moresilotype = {};
addModEventListener(moresilotype);

function moresilotype:loadMap(name)
	print("--- loading More BunkerSilo mod V1.0 --- (by derelky)")
	moresilograssilage=g_currentMission.usegrassilage
end;


function moresilotype.loadexpand(bunkerSilo, superFunc, ...)
    superFunc(bunkerSilo, ...)
	bunkerSilo.OrigoutputFillType = bunkerSilo.outputFillType

    return true
end


function moresilotype:Changesilotype(inputFillType,noEventSend)
	if self.OrigoutputFillType == g_fillTypeManager:getFillTypeIndexByName("silage") then
		self.inputFillType = inputFillType;
		if		self.inputFillType==g_fillTypeManager:getFillTypeIndexByName("grassilageraw") then
					self.outputFillType=g_fillTypeManager:getFillTypeIndexByName("grassilage");
		elseif	self.inputFillType==g_fillTypeManager:getFillTypeIndexByName("ccmraw") then
					self.outputFillType=g_fillTypeManager:getFillTypeIndexByName("ccm");
		else
					self.inputFillTypenew=g_fillTypeManager:getFillTypeIndexByName("chaff");
					self.outputFillType=g_fillTypeManager:getFillTypeIndexByName("silage");
		end;
		
		
		self.acceptedFillTypes = {};
		if moresilograssilage then 	
			if inputFillType == g_fillTypeManager:getFillTypeIndexByName("grassilageraw") then
				dataString = "grassilageraw grass_windrow dryGrass_windrow";
				dataStringout = "chaff ccmraw";
			elseif inputFillType == g_fillTypeManager:getFillTypeIndexByName("ccmraw") then
				dataString = "ccmraw";
				dataStringout = "grass_windrow dryGrass_windrow grassilageraw chaff";
			else
				dataString = "chaff";
				dataStringout = "ccmraw grass_windrow dryGrass_windrow grassilageraw";
			end;
		else
			if inputFillType == g_fillTypeManager:getFillTypeIndexByName("ccmraw") then
				dataString = "ccmraw";
				dataStringout = "grass_windrow dryGrass_windrow grassilageraw chaff";
			else
				dataString = "chaff grass_windrow dryGrass_windrow grassilageraw";
				dataStringout = "ccmraw";
			end;	
		end;
		
		
		local data = StringUtil.splitString(" ", dataString);
		for i=1,table.getn(data) do
			local fillType = g_fillTypeManager:getFillTypeIndexByName(data[i]);
			if fillType ~= nil then
				self.acceptedFillTypes[fillType] = true;
			else
				print("Warning: BunkerSilo has an invalid fillType (acceptedFillTypes): "..tostring(data[i]));
			end;
		end;
		
		local area = self.bunkerSiloArea;
		local dataout =  StringUtil.splitString(" ", dataStringout);
		for i=1,table.getn(dataout) do
			local fillType = g_fillTypeManager:getFillTypeIndexByName(dataout[i]);
			if fillType ~= nil then
				 DensityMapHeightUtil.changeFillTypeAtArea(area.sx,area.sz, area.wx,area.wz, area.hx,area.hz, fillType, inputFillType)
			else
				print("Warning: BunkerSilo has an invalid fillType (outputFillType): "..tostring(dataout[i]));
			end;
		end;
			
		if self.state == BunkerSilo.STATE_FILL then
		g_densityMapHeightManager:removeConvertingFillTypeAreas(self.bunkerSiloArea)
		g_densityMapHeightManager:setConvertingFillTypeAreas(self.bunkerSiloArea, self.acceptedFillTypes, inputFillType)
		
		end;
		self:raiseDirtyFlags(self.bunkerSiloDirtyFlag)
		setModeEventsetsilo.sendEvent(self, inputFillType, noEventSend)
	end;
end;



function moresilotype:saveToXMLFile(xmlFile, key, usedModNames)
	local filltypename=g_fillTypeManager.indexToName[self.inputFillType]
    setXMLString(xmlFile, key.."#fillType", filltypename)
end;

function moresilotype.loadFromXMLFile(bunkerSilo, superFunc, xmlFile, key)

	 local fillTypename = getXMLString(xmlFile, key.."#fillType")
     if fillTypename ~= nil then
	 local inputFillType =	g_fillTypeManager:getFillTypeIndexByName(fillTypename)

           bunkerSilo:Changesilotype(inputFillType)
     end
	 superFunc(bunkerSilo, xmlFile, key)
	 return true
end;

moresilotyperstr = BunkerSilo.readStream
function BunkerSilo:readStream(streamId, connection)
	moresilotyperstr(self,streamId, connection)
     if connection:getIsServer() then
        moresilograssilage = streamReadBool(streamId);
        self.inputFillType = streamReadUIntN(streamId,FillTypeManager.SEND_NUM_BITS);
		self:Changesilotype(self.inputFillType, true)
    end;
end;

moresilotypewstr = BunkerSilo.writeStream
function BunkerSilo:writeStream(streamId, connection)
	moresilotypewstr(self,streamId, connection)
    if not connection:getIsServer() then
        streamWriteBool(streamId, moresilograssilage);
        streamWriteUIntN(streamId, self.inputFillType, FillTypeManager.SEND_NUM_BITS);
    end;
end;


function moresilotype:addRemoveInputs()
	if self.eventId == nil then
		local _, eventId = g_inputBinding:registerActionEvent(InputAction.CHANGE_SILO, self, self.onActivateObject, false, true, false, true);
		self.eventId = eventId;
	else
		g_inputBinding:removeActionEvent(self.eventId);
		self.eventId = nil;
	end;
end;

function moresilotype:onActivateObject()
		
			if moresilograssilage then 	
				if	self.inputFillType==g_fillTypeManager:getFillTypeIndexByName("chaff") then
					self.inputFillTypenew=g_fillTypeManager:getFillTypeIndexByName("grassilageraw");
				elseif	self.inputFillType==g_fillTypeManager:getFillTypeIndexByName("grassilageraw") then
					self.inputFillTypenew=g_fillTypeManager:getFillTypeIndexByName("ccmraw");
				else
					self.inputFillTypenew=g_fillTypeManager:getFillTypeIndexByName("chaff");
				end;
			else	
				if	self.inputFillType==g_fillTypeManager:getFillTypeIndexByName("chaff") then
					self.inputFillTypenew=g_fillTypeManager:getFillTypeIndexByName("ccmraw");
				else
					self.inputFillTypenew=g_fillTypeManager:getFillTypeIndexByName("chaff");
				end;
			end

			self.inputFillType=self.inputFillTypenew;
			
			self:Changesilotype(self.inputFillType);
		
end;



function moresilotype:interactionTriggerCallback(triggerId, otherId, onEnter, onLeave, onStay, otherShapeId)
local switch = false
if self.state ~= BunkerSilo.STATE_FILL or self.fillLevel > 1000 and not self.OrigoutputFillType == g_fillTypeManager:getFillTypeIndexByName("silage") then
else
	switch = true
end

if g_currentMission.player ~= nil and otherId == g_currentMission.player.rootNode and switch then
    self:addRemoveInputs()
end
end




setModeEventsetsilo = {}
setModeEventsetsilo_mt = Class(setModeEventsetsilo, Event)

InitEventClass(setModeEventsetsilo, "setModeEventsetsilo")

function setModeEventsetsilo:emptyNew()
    local self = Event:new(setModeEventsetsilo_mt)
    return self
end

function setModeEventsetsilo:new(object, inputFillType)
    local self = setModeEventsetsilo:emptyNew()
    self.object = object
	self.inputFillType = inputFillType
    return self
end

function setModeEventsetsilo:readStream(streamId, connection)
    -- local id = streamReadInt32(streamId)
	self.object = NetworkUtil.readNodeObject(streamId);
	self.inputFillType = streamReadUIntN(streamId,FillTypeManager.SEND_NUM_BITS)
    --self.object = networkGetObject(id)
    self:run(connection)
end

function setModeEventsetsilo:writeStream(streamId, connection)
    -- streamWriteInt32(streamId, networkGetObjectId(self.object))
	NetworkUtil.writeNodeObject(streamId, self.object);
	streamWriteUIntN(streamId, self.inputFillType,FillTypeManager.SEND_NUM_BITS)
end;

function setModeEventsetsilo:run(connection)
	self.object:Changesilotype(self.inputFillType, true);
    if not connection:getIsServer() then
        g_server:broadcastEvent(setModeEventsetsilo:new(self.object, self.inputFillType), nil, connection, self.object)
    end
end

function setModeEventsetsilo.sendEvent(BSilo, inputFillType, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(setModeEventsetsilo:new(BSilo, inputFillType), nil, nil, BSilo)
		else
			g_client:getServerConnection():sendEvent(setModeEventsetsilo:new(BSilo, inputFillType))
		end
	end
end




BunkerSilo.interactionTriggerCallback = Utils.appendedFunction(BunkerSilo.interactionTriggerCallback, moresilotype.interactionTriggerCallback)
BunkerSilo.Changesilotype = moresilotype.Changesilotype;
BunkerSilo.onActivateObject = moresilotype.onActivateObject;
BunkerSilo.addRemoveInputs = moresilotype.addRemoveInputs;
BunkerSilo.load = Utils.overwrittenFunction(BunkerSilo.load, moresilotype.loadexpand)
BunkerSilo.saveToXMLFile = Utils.appendedFunction(BunkerSilo.saveToXMLFile, moresilotype.saveToXMLFile)
BunkerSilo.loadFromXMLFile = Utils.overwrittenFunction(BunkerSilo.loadFromXMLFile, moresilotype.loadFromXMLFile)
