--
-- MoreBunkersilo Mod by derelky
-- Help to register new fillTypes by Wopster
-- Version 1.0 initial Release LS19

local modDirectory = g_currentModDirectory

function onLoadMapFinished(mission, node)

    if node ~= 0 then
        local priceMaize = g_fillTypeManager:getFillTypeByName("MAIZE").pricePerLiter
        local priceSilage = g_fillTypeManager:getFillTypeByName("SILAGE").pricePerLiter
		
		
        local ccmHudFile = "hud/hud_fill_ccm.png"
        local ccmHudFileSmall = "hud/hud_fill_ccm_sml.png"
        local ccmrawHudFile = "hud/hud_fill_ccmraw.png"
        local ccmrawHudFileSmall = "hud/hud_fill_ccmraw_sml.png"
		
        local grassilageHudFile = "hud/hud_fill_grassilage.png"
        local grassilageHudFileSmall = "hud/hud_fill_grassilage_sml.png"
        local grassilagerawHudFile = "hud/hud_fill_grassilageraw.png"
        local grassilagerawHudFileSmall = "hud/hud_fill_grassilageraw_sml.png"
		
		local ccmHeapDiffuse = Utils.getFilename("fillPlanes/ccm_diffuse.png", modDirectory)
        local ccmHeapnormal  = Utils.getFilename("fillPlanes/ccm_normal.png", modDirectory)  
        local ccmHeapdistance = Utils.getFilename("fillPlanes/distance/ccmDistance_diffuse.png", modDirectory)  
		
        local ccmrawHeapDiffuse  = Utils.getFilename("fillPlanes/ccm_raw_diffuse.png", modDirectory)
        local ccmrawHeapnormal   = Utils.getFilename("fillPlanes/ccm_normal.png", modDirectory) 
        local ccmrawHeapdistance = Utils.getFilename("fillPlanes/distance/ccm_rawDistance_diffuse.png", modDirectory) 
		
        local grassilageHeapDiffuse  = Utils.getFilename("fillPlanes/grassilage_diffuse.png", modDirectory)
        local grassilageHeapnormal   = Utils.getFilename("fillPlanes/grassilage_normal.png", modDirectory)
        local grassilageHeapdistance = Utils.getFilename("fillPlanes/distance/grassilageDistance_diffuse.png", modDirectory)
		
        local grassilagerawHeapDiffuse  = Utils.getFilename("fillPlanes/grassilage_raw_diffuse.png", modDirectory)
        local grassilagerawHeapnormal   = Utils.getFilename("fillPlanes/grassilage_normal.png", modDirectory) 
        local grassilagerawHeapdistance = Utils.getFilename("fillPlanes/distance/grassilage_rawDistance_diffuse.png", modDirectory) 
		
		
		
		
		--register Fill and Densitymap
		print("Register filltype: ccm, ccmraw, grassilage and grassilageraw")
        local ccmFilType = g_fillTypeManager:addFillType("CCM", g_i18n:getText("fillType_ccm"), true, priceMaize * 1.7, 0.00045, math.rad(40), ccmHudFile, ccmHudFileSmall,modDirectory, nil, { 1, 1, 1 }, nil, false)
        local ccmrawFilType = g_fillTypeManager:addFillType("CCMRAW", g_i18n:getText("fillType_ccmraw"), false, priceMaize, 0.00045, math.rad(20), ccmrawHudFile, ccmrawHudFileSmall, modDirectory, nil, { 1, 1, 1 }, nil, false)
        local grassilageFilType = g_fillTypeManager:addFillType("GRASSILAGE", g_i18n:getText("fillType_grassilage"), true, priceSilage, 0.00045, math.rad(40), grassilageHudFile, grassilageHudFileSmall, modDirectory, nil, { 1, 1, 1 }, nil, false)
        local grassilagerawFilType = g_fillTypeManager:addFillType("GRASSILAGERAW", g_i18n:getText("fillType_grassilageraw"), false, priceSilage, 0.00045, math.rad(35), grassilagerawHudFile, grassilagerawHudFileSmall, modDirectory, nil, { 1, 1, 1 }, nil, false)
		
		
		local ccmHeightmapt = g_densityMapHeightManager:addDensityMapHeightType("CCM", math.rad(40), 1, 0, 0, 1, 1, false, ccmHeapDiffuse, ccmHeapnormal, ccmHeapdistance, false)
		local ccmrawHeightmapt = g_densityMapHeightManager:addDensityMapHeightType("CCMRAW", math.rad(20), 1, 0.05, 0, 1, 1, true, ccmrawHeapDiffuse,ccmrawHeapnormal, ccmrawHeapdistance, false)
		local grassilageHeightmapt = g_densityMapHeightManager:addDensityMapHeightType("GRASSILAGE", math.rad(40), 1, 0, 0, 1, 1, false,grassilageHeapDiffuse, grassilageHeapnormal, grassilageHeapdistance, false)
		local grassilagerawHeightmapt = g_densityMapHeightManager:addDensityMapHeightType("GRASSILAGERAW", math.rad(40), 0.7, 0.1, 0.2, 1, 1, true,grassilagerawHeapDiffuse,grassilagerawHeapnormal, grassilagerawHeapdistance, false)
				
		--load MaterialHolder		
		loadI3DFile(modDirectory .. "fillPlanes/fillPlane_materialHolder.i3d")
		loadI3DFile(modDirectory .. "particleSystems/particle_materialHolder.i3d")	
		loadI3DFile(modDirectory .. "particleSystems/effect_materialHolder.i3d")	

		--add the new Filltypes to FillCategorys so it can be load in it
		local CCMCategory = {"BULK", "TRAINWAGON", "LOADINGVEHICLE"}
		local GRASSILAGECategory = {"BULK", "LOADINGVEHICLE","FORAGEWAGON","SILAGETRAILER","FORK"}
		for _,k in pairs(CCMCategory) do
			g_fillTypeManager:addFillTypeToCategory(ccmFilType.index, g_fillTypeManager.nameToCategoryIndex[k])	
			g_fillTypeManager:addFillTypeToCategory(ccmrawFilType.index, g_fillTypeManager.nameToCategoryIndex[k])	
		end
		for _,j in pairs(GRASSILAGECategory) do
		
			g_fillTypeManager:addFillTypeToCategory(grassilageFilType.index, g_fillTypeManager.nameToCategoryIndex[j])	
			g_fillTypeManager:addFillTypeToCategory(grassilagerawFilType.index, g_fillTypeManager.nameToCategoryIndex[j])	
		end
		
		local foodhasmaize = false
		local foodgroupig = 0
		local foodhasccm = false
		for g,_ in pairs(g_animalFoodManager.foodGroups.PIG.content) do
			for _,n in pairs(g_animalFoodManager.foodGroups.PIG.content[g].fillTypes) do
				if g_fillTypeManager:getFillTypeNameByIndex(n) =="MAIZE" then
					foodhasmaize=true
					foodgroupig=g
				end
				if g_fillTypeManager:getFillTypeNameByIndex(n) =="CCM" then
					foodhasccm=true
				end
			end
			--print("Foodgroup: "..tostring(filltypesfood))
		end
		
		if foodhasmaize and not foodhasccm then
		  table.insert(g_animalFoodManager.foodGroups.PIG.content[foodgroupig].fillTypes, ccmFilType.index) 
		end		
		
		local foodhasgrass = false
		local foodgroupsheep = 0
		local foodhasgrassilagesheep = false
		for g,_ in pairs(g_animalFoodManager.foodGroups.SHEEP.content) do
			for _,n in pairs(g_animalFoodManager.foodGroups.SHEEP.content[g].fillTypes) do
				if g_fillTypeManager:getFillTypeNameByIndex(n) =="GRASS_WINDROW" then
					foodhasgrass=true
					foodgroupsheep=g
				end
				if g_fillTypeManager:getFillTypeNameByIndex(n) =="GRASSILAGE" then
					foodhasgrassilagesheep=true
				end
			end
			--print("Foodgroup: "..tostring(filltypesfood))
		end
		
		if foodhasgrass and not foodhasgrassilagesheep then
		  table.insert(g_animalFoodManager.foodGroups.SHEEP.content[foodgroupsheep].fillTypes, grassilageFilType.index) 
		end

		
		local foodhasgrasscow = false
		local foodgroupcow = 0
		local foodhasgrassilagecow = false
		for g,_ in pairs(g_animalFoodManager.foodGroups.COW.content) do
			for _,n in pairs(g_animalFoodManager.foodGroups.COW.content[g].fillTypes) do
				if g_fillTypeManager:getFillTypeNameByIndex(n) =="GRASS_WINDROW" then
					foodhasgrasscow=true
					foodgroupcow=g
				end
				if g_fillTypeManager:getFillTypeNameByIndex(n) =="GRASSILAGE" then
					foodhasgrassilagecow=true
				end
			end
			--print("Foodgroup: "..tostring(filltypesfood))
		end
		
		if foodhasgrasscow and not foodhasgrassilagecow then
		  table.insert(g_animalFoodManager.foodGroups.COW.content[foodgroupcow].fillTypes, grassilageFilType.index) 
		end		
		 -- refresh FilltypeManager
        g_currentMission.hud.fillLevelsDisplay:refreshFillTypes(g_fillTypeManager)
		
		g_currentMission.usegrassilage = false
	    if mission:getIsServer() and mission.missionInfo.savegameDirectory ~= nil and fileExists(mission.missionInfo.savegameDirectory .. "/mbs.xml") then
            local xmlFile = loadXMLFile("MBSXML", mission.missionInfo.savegameDirectory .. "/mbs.xml")
            if xmlFile ~= nil then
				local key = "mbs";
				local usegrassilage = getXMLBool(xmlFile, key.."#usegrassilage");
				g_currentMission.usegrassilage = usegrassilage;
                delete(xmlFile)
            end
        end	

		
		
    end
	
end

function saveToXMLFile(missionInfo)

    if missionInfo.isValid then
		local key = "mbs";
        local xmlFile = createXMLFile("MBSXML", missionInfo.savegameDirectory .. "/mbs.xml", key)
        if xmlFile ~= nil then
			setXMLBool(xmlFile, key .. "#usegrassilage",g_currentMission.usegrassilage);
			saveXMLFile(xmlFile);
			delete(xmlFile);
        end
    end
end


function addtoseasonseconomy(mission)
		if g_seasons == nil then
		else
			if g_seasons.economy.data.repricing.fillTypes.CCM  == nil then
				g_seasons.economy.data.repricing.fillTypes.CCM = {}
				for i,j in pairs(g_seasons.economy.data.repricing.fillTypes.MAIZE) do
				g_seasons.economy.data.repricing.fillTypes.CCM[i]=j
				end
			end
			if g_seasons.economy.data.repricing.fillTypes.GRASSILAGE  == nil then
				g_seasons.economy.data.repricing.fillTypes.GRASSILAGE = {}
				for i,j in pairs(g_seasons.economy.data.repricing.fillTypes.SILAGE) do
				g_seasons.economy.data.repricing.fillTypes.GRASSILAGE[i]=j
				end
			end
		end	
end

function load(id, xmlFile, key,customEnvironment)
	-- Add the new Filltype to the SellingStations
		local hasmaize =false
		local hassilage =false
		local hasccm=false
		local hasgrassilage =false
		
		local object=id
			
		
		if object == nil then
		else
		hasmaize =false
		hassilage =false
		hasccm=false
		hasgrassilage =false
			for i,filltype in pairs(object.acceptedFillTypes) do
					
			local fillname=g_fillTypeManager.indexToName[i]

			if fillname == "MAIZE" then
				hasmaize=true
							
			end
			if fillname == "CCM" then
				hasccm=true
							
			end

			if fillname == "SILAGE" then
				hassilage=true
							
			end
			if fillname == "GRASSILAGE" then
				hasgrassilage=true
							
			end
			
			end
			
			if hasmaize and not hasccm then
				--add CCM to the same SellingStation that accept MAIZE
				local filltypen = g_fillTypeManager:getFillTypeIndexByName("CCM")
				local price = g_fillTypeManager:getFillTypeByName("CCM").pricePerLiter
				object:addAcceptedFillType(filltypen,price,true,false)
				object.priceMultipliers[ g_fillTypeManager:getFillTypeIndexByName("CCM")]=object.priceMultipliers[ g_fillTypeManager:getFillTypeIndexByName("MAIZE")]
				object:initPricingDynamics()
			end
			
			if hassilage and not hasgrassilage then
				--add GRASSILAGE to the same SellingStation that accept SILAGE
				local filltypen = g_fillTypeManager:getFillTypeIndexByName("GRASSILAGE")
				local price = g_fillTypeManager:getFillTypeByName("GRASSILAGE").pricePerLiter
				object:addAcceptedFillType(filltypen,price,true,false)
				object.priceMultipliers[ g_fillTypeManager:getFillTypeIndexByName("GRASSILAGE")]=object.priceMultipliers[ g_fillTypeManager:getFillTypeIndexByName("SILAGE")]
				object:initPricingDynamics()
			end
			
		end
end

-- Hook here
FSBaseMission.loadMapFinished = Utils.prependedFunction(FSBaseMission.loadMapFinished, onLoadMapFinished)
Mission00.loadItemsFinished = Utils.prependedFunction(Mission00.loadItemsFinished, addtoseasonseconomy)
FSCareerMissionInfo.saveToXMLFile = Utils.appendedFunction(FSCareerMissionInfo.saveToXMLFile, saveToXMLFile)
SellingStation.load = Utils.appendedFunction(SellingStation.load, load)
